SystemOrganization addCategory: #'SBE-Quinto'!

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame methodsFor: 'as yet unclassified' stamp: 'MLM 9/27/2020 22:19'!
cellsPerSide 
	"Cuantas celdas tiene el juego"
	^20
	! !

!SBEGame methodsFor: 'initialization' stamp: 'MLM 9/27/2020 22:14'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self
		bounds: (5 @ 5 extent: width * n @ (height * n) + (2 * self borderWidth)).
	cells := Matrix
				new: n
				tabulate: [:i :j | self newCellAt: i at: j]! !

!SBEGame methodsFor: 'as yet unclassified' stamp: 'MLM 9/28/2020 23:39'!
newCellAt: i at: j 
	"no comment"
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: i - 1 * c width @ (j - 1 * c height) + origin.
	c
		mouseAction: [self toggleNeighboursOfCellAt: i at: j].
		^c! !

!SBEGame methodsFor: 'as yet unclassified' stamp: 'MLM 9/28/2020 23:23'!
toggleNeighboursOfCellAt: i at: j 
	i > 1
		ifTrue: [(cells at: i - 1 at: j) toggleState].
	i < self cellsPerSide
		ifTrue: [(cells at: i + 1 at: j) toggleState].
	j > 1
		ifTrue: [(cells at: i at: j - 1) toggleState].
	j < self cellsPerSide
		ifTrue: [(cells at: i at: j + 1) toggleState].! !

!SBEGame methodsFor: 'accessing' stamp: 'MLM 9/28/2020 23:32'!
toggleState
	self shouldBeImplemented! !

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'MLM 9/27/2020 18:17' prior: 0!
Mira!! un comentario!

!SBECell methodsFor: 'initialization' stamp: 'MLM 9/27/2020 21:56'!
initialize 
	"pa que dibujen los muchachos"

	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.

	! !

!SBECell methodsFor: 'as yet unclassified' stamp: 'MLM 9/28/2020 23:26'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'accessing' stamp: 'MLM 9/28/2020 23:28'!
mouseUp: anEvent
	mouseAction value ! !
